;==============================================================================
; Build as console app.
;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================

printf MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke crt_printf, cfm$(format), args
    ELSE
        invoke crt_printf, cfm$(format)
    ENDIF
    EXITM <>
ENDM

;==============================================================================

MENUBARINFO STRUCT
    cbSize    DWORD ?
    rcBar     RECT  <>
    hMenu     HMENU ?
    hwndMenu  HWND  ?
    focused   DWORD ?
MENUBARINFO ENDS

;==============================================================================

IDM_FILE equ 100
IDM_EDIT equ 101
IDM_VIEW equ 102
IDM_HELP equ 103

;==============================================================================
    .data
        hMenu     dd 0
        hFileMenu dd 0
        hEditMenu dd 0
        hViewMenu dd 0
        hHelpMenu dd 0
        mbi       MENUBARINFO <SIZEOF MENUBARINFO>
    .code
;==============================================================================

SetClientSize proc uses ebx hwnd:HWND, pixelWidth:DWORD, pixelHeight:DWORD

    LOCAL rcc:RECT, rcw:RECT

    invoke GetClientRect, hwnd, ADDR rcc
    invoke GetWindowRect, hwnd, ADDR rcw

    mov ecx, rcw.right
    sub ecx, rcw.left       ; ecx = window width - 1

    mov eax, pixelWidth
    dec eax                 ; eax = pixelWidth - 1
    mov ebx, rcc.right      ; ebx = client width - 1
    sub ebx, eax            ; ebx = difference
    sub ecx, ebx            ; adjust width

    mov edx, rcw.bottom     ; edx = window height - 1
    sub edx, rcw.top

    mov eax, pixelHeight
    dec eax                 ; eax = pixelHeight - 1
    mov ebx, rcc.bottom     ; ebx = client height - 1
    sub ebx, eax            ; ebx = difference
    sub edx, ebx            ; adjust height

    invoke MoveWindow, hwnd, rcw.left, rcw.top, ecx, edx, TRUE

    ret

SetClientSize endp

;==============================================================================

DlgProc proc hwndDlg:dword, uMsg:dword, wParam:dword, lParam:dword

    LOCAL rc:RECT
    LOCAL pt:POINT

    SWITCH uMsg

      CASE WM_INITDIALOG

          invoke CreateMenu
          mov hMenu, eax
          invoke CreateMenu
          mov hFileMenu, eax
          invoke CreateMenu
          mov hEditMenu, eax
          invoke CreateMenu
          mov hViewMenu, eax
          invoke CreateMenu
          mov hHelpMenu, eax
          invoke AppendMenu, hMenu, MF_POPUP, hFileMenu, chr$("&File")
          invoke AppendMenu, hMenu, MF_POPUP, hEditMenu, chr$("&Edit")
          invoke AppendMenu, hMenu, MF_POPUP, hViewMenu, chr$("&View")
          invoke AppendMenu, hMenu, MF_POPUP, hHelpMenu, chr$("&Help")
          invoke SetMenu, hwndDlg, hMenu

          ;--------------------------------------------------------
          ; Get the menu info for the fourth item on the menu bar.
          ;--------------------------------------------------------

          invoke GetMenuBarInfo, hwndDlg, OBJID_MENU, 4, ADDR mbi
          printf("GetMenuBarInfo: %d\n", eax)

          ;----------------------------------------------------------------
          ; Convert the returned screen coordinates to client coordinates.
          ; The Y coordinate will be discarded.
          ;----------------------------------------------------------------

          printf("mbi.rcBar.right: %d\n", mbi.rcBar.right)
          push mbi.rcBar.right
          pop pt.x
          push 0
          pop pt.y
          invoke ScreenToClient, hwndDlg, ADDR pt
          printf("pt.x: %d\n", pt.x)

          ;----------------------------------------------------------
          ; Get the current client coordinates, need rc.bottom only.
          ;----------------------------------------------------------

          invoke GetClientRect, hwndDlg, ADDR rc
          printf("rc.right: %d\n", rc.right)
          printf("rc.bottom: %d\n", rc.bottom)

          ;------------------------------------
          ; Adjust rc.bottom to client height.
          ;------------------------------------

          inc rc.bottom

          ;----------------------------------------------------
          ; Under Windows 2000 this adjuatment is necessary to
          ; prevent the menu from wrapping.
          ;----------------------------------------------------

          add pt.x, 12
          printf("pt.x+12: %d\n", pt.x)

          ;---------------------------------------------------
          ; Set the new width and leave the height unchanged.
          ;---------------------------------------------------

          invoke SetClientSize, hwndDlg, pt.x, rc.bottom

          ;---------------
          ; Check result.
          ;---------------

          invoke GetClientRect, hwndDlg, ADDR rc
          printf("rc.right after sizing: %d\n", rc.right)
          printf("rc.bottom after sizing: %d\n", rc.bottom)


      CASE WM_COMMAND

          SWITCH wParam

              CASE IDCANCEL

                  invoke EndDialog, hwndDlg, 0

          ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, 0

    ENDSW

    xor eax, eax
    ret

DlgProc endp

;==============================================================================
start:
;==============================================================================

    Dialog "Test", "MS Sans Serif",10, \
           WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
           0,0,0,120,60,1024

    invoke GetModuleHandle, NULL

    CallModalDialog eax,0,DlgProc,NULL

    exit
;==============================================================================
end start
